# coding: utf-8

"""
    IotaService

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Contact: info@affinidi.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictStr, confloat, conint, conlist, validator
from affinidi_tdk_iota_client.models.iota_configuration_dto_client_metadata import IotaConfigurationDtoClientMetadata

class CreateIotaConfigurationInput(BaseModel):
    """
    CreateIotaConfigurationInput
    """
    name: StrictStr = Field(default=..., description="The name of the configuration to quickly identify the resource.")
    description: Optional[StrictStr] = Field(default=None, description="An optional description of what the configuration is used for.")
    wallet_ari: StrictStr = Field(default=..., alias="walletAri", description="The unique resource identifier of the Wallet used to sign the request token.")
    iota_response_webhook_url: Optional[StrictStr] = Field(default=None, alias="iotaResponseWebhookURL", description="The webhook URL is used for callback when the data is ready.")
    enable_verification: StrictBool = Field(default=..., alias="enableVerification", description="Cryptographically verifies the data shared by the user when enabled.")
    enable_consent_audit_log: StrictBool = Field(default=..., alias="enableConsentAuditLog", description="Records the user's consent when they share their data, including the type of data shared when enabled.")
    token_max_age: Optional[Union[confloat(ge=1, strict=True), conint(ge=1, strict=True)]] = Field(default=None, alias="tokenMaxAge", description="This is the lifetime of the signed request token during the data-sharing flow.")
    client_metadata: IotaConfigurationDtoClientMetadata = Field(default=..., alias="clientMetadata")
    mode: Optional[StrictStr] = Field(default='websocket', description="Determines whether to handle the data-sharing request using the WebSocket or Redirect flow.")
    redirect_uris: Optional[conlist(StrictStr)] = Field(default=None, alias="redirectUris", description="List of allowed URLs to redirect users, including the response from the request. This is required if the selected data-sharing mode is Redirect.")
    enable_idv_providers: Optional[StrictBool] = Field(default=None, alias="enableIdvProviders", description="Enables identity verification from user with a 3rd-party provider when a verified identity document is not found.")
    __properties = ["name", "description", "walletAri", "iotaResponseWebhookURL", "enableVerification", "enableConsentAuditLog", "tokenMaxAge", "clientMetadata", "mode", "redirectUris", "enableIdvProviders"]

    @validator('mode')
    def mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('redirect', 'websocket'):
            raise ValueError("must be one of enum values ('redirect', 'websocket')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateIotaConfigurationInput:
        """Create an instance of CreateIotaConfigurationInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of client_metadata
        if self.client_metadata:
            _dict['clientMetadata'] = self.client_metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateIotaConfigurationInput:
        """Create an instance of CreateIotaConfigurationInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateIotaConfigurationInput.parse_obj(obj)

        _obj = CreateIotaConfigurationInput.parse_obj({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "wallet_ari": obj.get("walletAri"),
            "iota_response_webhook_url": obj.get("iotaResponseWebhookURL"),
            "enable_verification": obj.get("enableVerification"),
            "enable_consent_audit_log": obj.get("enableConsentAuditLog"),
            "token_max_age": obj.get("tokenMaxAge"),
            "client_metadata": IotaConfigurationDtoClientMetadata.from_dict(obj.get("clientMetadata")) if obj.get("clientMetadata") is not None else None,
            "mode": obj.get("mode") if obj.get("mode") is not None else 'websocket',
            "redirect_uris": obj.get("redirectUris"),
            "enable_idv_providers": obj.get("enableIdvProviders")
        })
        return _obj


